-- ގ ver.lua  2010-02-19
module("mushiki", package.seeall)
NSExec("nsa")
-- NSExecI
function exec(com, ...) -- NSExec̃bp[
	local args = {...}
	-- tB^O
	if type(com) ~= "string" then return end
	if com:len() == 0 then return end

	local exec = "_"..com
	local arg
--	NSOkBox(tostring(#args), "args")
	if 0 < # args then
		exec = exec .. " "
		while 0 < # args do
			arg = table.remove(args, 1)
			if type(arg) == "string" then
				exec = exec .. '"'..arg..'"'
			elseif type(arg) == "number" then
				exec = exec .. tostring(arg)
			elseif type(arg) == "table" then
				local num
				if arg.str then exec = exec .. '$'; num = arg.str end
				if arg.int then exec = exec .. '%'; num = arg.int end
				if arg.dim then exec = exec .. '?'; num = arg.dim end
				if arg.id then num = arg.id end
				if type(num) == "string" then
					exec = exec .. num
				else
					exec = exec.. tostring(num)
				end
			else
			end
			if 0 < # args then exec = exec .. ',' end
		end
	end
--	NSOkBox(exec, "exec")
	return NSExec(exec)
end
-- ɂ́ANScripterɎs߂𕶎ŗ^B
-- ȍ~͕␔lDȂׂBʂăNH[gB
-- ϐuꍇ́A{str='numalias'}Ƃ{int=45}ƂgB
-- dim͂܂l悤B

-- luasub ݒ肷I
function luasub(com_name, com_function)
	if type(com_name) ~= "string" then return nil end -- p[^`FbN {́ALȕ񂩂ǂ񂾂ǂB
	if type(com_function) ~= "function" then return nil end -- p[^`FbN
	local func_name = "NSCOM_"..com_name
	if type(_G[func_name]) == "function" then -- d錾`FbNB
		NSOkBox(com_name.."͊ɐ錾Ă܂B", "luasub")
		return nil
	end
	_G[func_name] = com_function -- Luao^
	NSExec("_luasub "..com_name) -- NScriptero^
	return true
end

-- G[R[hfI
function error_end(message, title)
	if type(title) ~= "string" then title = "ގB" end
	NSOkBox(message, title)
	_G["NSEnd"]()
end

-- pSpI
-- ^ꂽl𕶎R[hƉ߂āAꂪpSpA1 or 2 ŕԂB
function letter_len_num(num) -- pȂ1ASpȂ2ԂB
	if num > 126 and num < 161 then return 2 end
	if num > 223 then return 2 end
	return 1
end

-- ^ꂽ̐擪pSpA1 or 2 ŕԂB
function letter_len(letter)
	return letter_len_num(letter:byte())
end

-- 镶ɑSp܂܂邩Aboolean ŕԂB
function is_all_hankaku(str)
	for i = 1, str:len() do
		if letter_len(str:sub(i)) == 2 then return false end
	end
	return true
end

function split(str, sepa) -- Xvb^
	if type(str) ~= "string" then return nil end
	if type(sepa) ~= "string" then return nil end
	str = str:gsub("%s*$", "") -- ̉s폜B΁B
--	NSOkBox(str, "str")
	if str:len() == 0 then return {} end
	if sepa:len() == 0 then return {string.char(str:byte(1, str:len()))} end
	if sepa:len() == 1 then return split_single(str, sepa) end -- Zp[^1̏ꍇAʂȏB
	local sepa2 = ""
	for d, letter in ipairs({string.char(sepa:byte(1, sepa:len()))}) do
		sepa2 = sepa2 .. '%'..letter
	end
	local res = {}
	local pattern = '(.-)'..sepa2
--	NSOkBox(pattern, "pattern")
	local last = str:gsub(pattern, function(cap) res[1+#res] = cap ; return '' end)
	res[1+#res] = last
	return res
end

function split_single(str, sepa) -- Xvb^BAZp[^͕ꕶɌB
--	NSOkBox(str, sepa)
	local res = {}
	local num = 1
	local letter
	for i = 1, str:len() do
		letter = string.char(str:byte(i))
--		NSOkBox(letter, "letter")
		if letter == sepa then
			num = num + 1
		else
			res[num] = res[num] or ""
			res[num] = res[num] .. letter
		end
	end
--	NSOkBox(tostring(#res), "len")
	return res
end

function join(t, sepa) -- WCi[
	if type(t) ~= "table" then return "" end
	if type(sepa) ~= "string" then return "" end
	local res = ""
	for i, token in ipairs(t) do
		if i > 1 then res = res .. sepa end
		res = res .. token
	end
	return res
end

function chomp(str, letter) -- str̖𒲂ׁAꂪletteri̘Ajꍇ͂폜ԂB
	local token = {}
	while string.char(str:byte(str:len())) == letter do
		str = join(split_single(str, letter), letter)
	end
	return str
end

-- t@CTBnsaTI
function fileexist_in_nsa(file)
	local temp = NSGetIntValue(0)
	exec("fileexist", {int=0}, file)
	local res = NSGetIntValue(0)
	NSSetIntValue(0, temp)
	if res == 0 then return false end
	return true
end

-- t@CTBnsa͒TȂI
function fileexist_no_nsa(file)
--	NSOkBox(file, "邩ȁH")
	local fh = io.open(file)
	if io.type(fh) ~= "file" then return false end
	fh:close()
	return true
end

function nsa_check(dir)
	if type(dir) ~= "string" then return nil end
	if dir:len() == 0 then return nil end
	-- ɃfBNg؂肪Ȃ΋؂t^B
	if dir:sub(-1) ~= "\\" then dir = dir.."\\" end
	if fileexist_no_nsa(dir.."arc.nsa") then return dir end
	return nil
end

local id2game_num = {} -- IDԍɕςe[uB
local game_list = {} -- WXg~ςe[uB
local game_num = 0 -- ݂̃Q[ԍ
local game_max = 0 -- Q[ԍ̍ől
local search_max = 0 -- ̍ől
local current_dir = ""

function read_reg() -- WXgǂݍށB
	game_max = game_max + 1 -- Q[ԍ1ݒ
	local fh = io.open("mushiki\\ini.txt") -- ݒt@C̓ǂݍ
	if io.type(fh) ~= "file" then error_end("ini.txt܂B") end -- ݒt@CȂI
	local back = NSGetStrValue(0) -- ޔ

	local reg1
	local reg2

	for line in fh:lines() do -- soBݒt@C
		local param = split(line, ",") -- 荞񂾍s𕪊
		local game = {} -- Q[i[IuWFNg

		-- ŏ̍ڂ́AQ[̖O
		game.name = table.remove(param, 1)
		-- ̓getregp
		reg1 = table.remove(param, 1)
		reg2 = table.remove(param, 1)
		exec("getreg", {str=0}, reg1, reg2)
		game.dir = NSGetStrValue(0) -- getreǧʂ擾B
		if type(game.dir) == "string" then game.dir = nsa_check(game.dir) end -- ̂ǂ`FbNB
--		NSOkBox(game.dir, "dir")
		-- ȍ~́ÃQ[IDB
		while 0 < # param do -- IDo^B
			id2game_num[table.remove(param, 1)] = game_max
		end
		-- Q[̓o^
		game_list[game_max] = game
		game_max = game_max + 1
	end
	game_max = game_max - 1
	NSSetStrValue(0, back) -- A
	fh:close()
	game_num = game_max
	search_max = game_max
end
read_reg() -- ͎sĂׂ

luasub("game_list", function()
	local str = ""
	for i = 1, game_max do
		if type(game_list[i].dir) == "string" then
			if str:len() > 0 then str = str .. " / " end
			str = str .. tostring(i) .. "." .. game_list[i].dir
		end
	end
	NSOkBox(str, "̊ɓĂQ[")
end)

function set_default(temp_id)
	if temp_id == "default" then
		search_max = game_max
		return
	end
	local temp = id2game_num[temp_id]
	if type(temp) ~= "string" then error_end(temp_id.."́A݂ȂIDłB") end
	search_max = temp
end
luasub("set_default", function() set_default(NSPopID()) end)

-- addnsadiȑ㏑
function addnsadir(dir)
	if current_dir == dir then return nil end
	current_dir = dir
	exec("addnsadir", dir)
	return true
end
luasub("addnsadir", function() addnsadir(NSPopStr()) end)
-- getnsadir̍쐬
luasub("getnsadir", function() NSSetStrValue(NSPopStrRef(), current_dir) end)

function chnsadir(num) -- ԍ^āÃQ[ԍɕύXB
	if type(game_list[num].dir) ~= "string" then return false end
	addnsadir(game_list[num].dir)
	game_num = num
	return true
end
function chnsadir2(code) -- ID^āÃQ[ɕύXB
	if type(id2game_num[code]) ~= "number" then return nil end
	return chnsadir(id2game_num[code])
end

-- t@CTB
-- nil߂ė́A݂ȂB
-- 񂪖߂ė́AtpX
-- ̂܂܂̕񂪖߂ė́Ansa̒ɂBAɕύXς݁B
local cache2path = {} -- LbV
local cache2dir = {} -- LbV
function fileexist(file)
	if type(file) ~= "string" then return nil end
	if file:len() == 0 then return nil end

	-- LbV@\
	local ret = cache2path[file]
	if ret then return ret end
	if cache2dir[file] then
		addnsadir(cache2dir[file])
		return file
	end

	-- ۂɌB
	if fileexist_no_nsa(file) then -- Jg
		cache2path[file] = file
		return file
	end
	local mode = is_all_hankaku(file) -- Sp
	for temp = search_max, 1, -1 do -- ő傩ŏ֔i߂B
		local game = game_list[temp] -- Q[̎擾
		if type(game.dir) == "string" then -- o^ȂΔ΂B
			if mode then -- SpȂ
--				NSOkBox(file, game.name.."T")
				addnsadir(game.dir)
				if fileexist_in_nsa(file) then
					cache2dir[file] = game.dir -- LbVo^
					ret = file
					break
				end
			end
			if fileexist_no_nsa(game.dir..file) then
				cache2path[file] = game.dir..file
				ret = game.dir..file
				break
			end
		end
	end
	return ret
end

luasub("cache_print", function()
	local fh = io.open("cache.txt", "w")
	if io.type(fh) ~= "file" then return end
	fh:write("tpXo^\n")
	for k, v in pairs(cache2path) do
		fh:write(k.."\t"..v.."\n")
	end
	fh:write("\n")
	fh:write("fBNgo^\n")
	for k, v in pairs(cache2dir) do
		fh:write(k.."\t"..v.."\n")
	end
	fh:close()
end)

function get_head(str) return str:sub(1, 1) end -- ̐擪̈ꕶԂB

function file_identify(str) -- ꂪt@Cǂ𔻕ʂB
	if type(str) ~= "string" then return nil end
	if str:len() == 0 then return nil end
	local file = "" -- t@Ci[B
	local tag = "" -- ^Oi[B
	-- 擪̈ꕶ擾B
	local head = get_head(str)
	 -- C[DLLƂ̌т̏ꍇB
	if head == "*" then return str end -- ԂB
	local second = str:sub(2, 2) -- ӂڂׂB
	if head == ":" then -- ^O݂B
		 -- XvCgȂ΁B
		if second == "s" then return str end -- ɖ߂B

		-- ȊOȂAt@C`FbN̗vB
		local temp = split(str, ";") -- ; ŕB^Oƃt@Cɕ
		tag = temp[1]..";"
		file = temp[2]
	elseif head == "(" then -- yp[vȂ΁B
		local temp = split(str, ")") -- ) ŕ
		tag = temp[1]..")"
		file = temp[2]
	else
		file = str
	end
	-- L[[h`FbN
	if file == "black" then return file end
	if file == "white" then return file end
	-- filȇ݃`FbN
	head = get_head(file)
	if head == ">" then -- hԂ̃AL@Ȃ
		-- ȂB
	else -- łȂ΁A
		file = fileexist(file)
		if type(file) ~= "string" then error_end(str.."݂܂B") end
	end
	-- ʂԂB
	return tag..file
end

-- ld ㏑
luasub("ld", function()
	local id = NSPopID()
	NSPopComma()
	local str = file_identify(NSPopStr())
	NSPopComma()
	exec("ld", {id=id}, str, NSPopInt())
end)
-- bg ㏑
luasub("bg", function()
	local str = file_identify(NSPopStr())
	NSPopComma()
	exec("bg", str, NSPopInt())
end)
-- lsp, lsph ㏑
function lsp(visible)
	local sp = NSPopInt()
	NSPopComma()
	local str = file_identify(NSPopStr())
	NSSpLoad(sp, str)

	if str:sub(1, 1) == "*" then return end
	NSPopComma()
	local x = NSPopInt()
	NSPopComma()
	local y = NSPopInt()
	local alpha = 255
	if NSCheckComma() then
		NSPopComma()
		alpha = NSPopInt()
	end
	NSSpMove(sp, x, y, alpha)
	NSSpVisible(sp, visible)
end
luasub("lsp", function() lsp(true) end)
luasub("lsph", function() lsp(false) end)

function lsp2(visible, ope)
	local sp = NSPopInt()
	NSPopComma()
	local str = file_identify(NSPopStr())
	NSPopComma()
	local x = NSPopInt()
	NSPopComma()
	local y = NSPopInt()
	NSPopComma()
	local xx = NSPopInt()
	NSPopComma()
	local yy = NSPopInt()
	NSPopComma()
	local rotate = NSPopInt()
	local alpha = 255
	if NSCheckComma() then
		NSPopComma()
		alpha = NSPopInt()
	end
	NSSp2Load(sp, str)
	NSSp2Move(sp, x, y, xx, yy, rotate, alpha, ope)
	NSSp2Visible(sp, visible)
end
luasub("lsp2", function() lsp2(true, 0) end)
luasub("lsph2", function() lsp2(false, 0) end)
luasub("lsp2add", function() lsp2(true, 1) end)
luasub("lsph2add", function() lsp2(false, 1) end)
luasub("lsp2sub", function() lsp2(true, 2) end)
luasub("lsph2sub", function() lsp2(false, 2) end)

-- y߂̏㏑
luasub("bgm", function() exec("bgm", file_identify(NSPopStr())) end)
luasub("bgmonce", function() exec("bgmonce", file_identify(NSPopStr())) end)
luasub("loopbgm", function()
	local file = NSPopStr()
	NSPopComma()
	exec("loopbgm", file_identify(file), file_identify(NSPopStr()))
end)
luasub("dwave", function()
	local ch = NSPopInt()
	NSPopComma()
	exec("dwave", ch, file_identify(NSPopStr()))
end)
luasub("dwaveload", function()
	local ch = NSPopInt()
	NSPopComma()
	exec("dwaveload", ch, file_identify(NSPopStr()))
end)
luasub("dwaveloop", function()
	local ch = NSPopInt()
	NSPopComma()
	exec("dwaveloop", ch, file_identify(NSPopStr()))
end)

-- exec_dll
function exec_dll(str)
--	NSOkBox(str, "exec_dll")
	local temp = NSGetStrValue(0)
	exec("exec_dll", str)
	exec("getret", {str=0})
	local ret = NSGetStrValue(0)
	NSSetStrValue(0, temp)
--	NSOkBox(ret, "ret")
	return ret
end

-- current_dirԂ֐B
local current_dir
function current() -- œ͍̂Ō\͂ĂȂB
	current_dir = current_dir or chomp(exec_dll("mushiki\\current.dll/108&"), "\\")
--	NSOkBox(current_dir, "current")
	return current_dir
end

-- recommend߂̍쐬
function recommend_end(global, dir)
	if global > 0 then
		if dir:len() > 0 then
			NSSetStrValue(global, dir)
		end
	end
	return true
end

luasub("recommend", function()
	local alias = NSPopID()
	local global = -1
	if NSCheckComma() then -- ꍇB
		NSPopComma()
		global = NSPopStrRef()
	end
	local game_num = id2game_num[alias]
	if type(game_num) ~= "number" then -- GCAX̑I
		error_end(alias.."́ALȃGCAXł͂܂B", "recommend")
	end
	local game = game_list[game_num] -- Q[̎擾
	if type(game.dir) == "string" then return recommend_end(global, game.dir) end -- o^Ȃ牽ȂB
	if global > 0 then
		game.dir = nsa_check(NSGetStrValue(global))
		if type(game.dir) == "string" then return recommend_end(global, game.dir) end -- o^Ȃ牽ȂB
	end
	-- łȂ΁AɏoԁB
	NSOkBox("u"..game.name.."varc.nsaIĂB", "ގB")
	local file = exec_dll(current().."\\mushiki\\dialog.dll/filename,nsat@C(*.nsa),*.nsa,ns2t@C(*.ns2),*.ns2,All")
	exec_dll(current().."\\mushiki\\current.dll/111&"..current()) -- JgfBNgɖ߂B
	if file == "" then return end -- ȂȂ牽ȂB
	-- ꂽ̂H
	local t = split(file, "\\")
	t[# t] = nil
	game.dir = nsa_check(join(t, "\\")) -- o^Ă݂B
--	NSOkBox(game.dir, "ꂽ")
	if type(game.dir) == "string" then return recommend_end(global, game.dir) end -- o^Ȃ牽ȂB
	-- Ȃ΁B
	error_end("̊ɂ"..game.name.."܂B", "recommend")
end)

